/*
 * Copyright (C) 1998,1999
 *	SHUDO Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

/* utilities for x86 Time Stamp Counter */

#include "x86tsc.h"

static unsigned long sh, sl, eh, el;
static unsigned long long overhead = 0;


void tscStart() {
#ifndef SUPRESS_PRELOAD
  /* preload tscEnd() to code cache */
  __asm__("movl  %0,%%edx" : : "m" (tscEnd));

  /* preload sh,sl to data cache */
  __asm__("movl  %0,%%edx\n\t"
	  "movl  %1,%%eax"
	  : : "m" (sh), "m" (sl) : "eax","edx");

  __asm__("nop\n\tnop");
#endif

#ifdef DISABLE_INTR
  __asm__("cli");
#endif
  __asm__(".byte 0x0f,0x31\n\t"	/* rdtsc */
	  "movl  %%edx,%0\n\t"
	  "movl  %%eax,%1"
	  : : "m" (sh), "m" (sl) : "eax","edx");
}


void tscEnd() {
  __asm__(".byte 0x0f,0x31");	/* rdtsc */
#ifdef DISABLE_INTR
  __asm__("sti");
#endif
  __asm__("movl  %%edx,%0\n\t"
	  "movl  %%eax,%1"
	  : : "m" (eh), "m" (el));
}


unsigned long long tscClock() {
  unsigned long long s,e;

  *((unsigned long *)&s) = sl;
  *((unsigned long *)&s + 1) = sh;
  *((unsigned long *)&e) = el;
  *((unsigned long *)&e + 1) = eh;

  e -= (s + overhead);
  return e;
}
